--- old/usr/src/cmd/cmd-inet/usr.lib/wanboot/p12split/Makefile	2014-05-16 10:29:50.496378818 +0400
+++ new/usr/src/cmd/cmd-inet/usr.lib/wanboot/p12split/Makefile	2014-05-16 10:29:50.505294214 +0400
@@ -25,9 +25,14 @@
 include ../Makefile.com
 
 PROG=		p12split
-LDLIBS +=	-lwanboot -linetutil -lwanbootutil -lcrypto
+LDLIBS +=	-lwanboot -linetutil -lwanbootutil
 CPPFLAGS +=	-I$(CMNCRYPTDIR)
 
+# libcrypto has no lint library, so we can only include this while building
+$(PROG) := LDLIBS += -lcrypto
+
+LINTFLAGS +=	-erroff=E_NAME_USED_NOT_DEF2
+
 all:		$(PROG)
 
 install:	all $(ROOTCMD)
--- old/usr/src/cmd/cmd-inet/usr.lib/wanboot/p12split/p12split.c	2014-05-16 10:29:50.730692038 +0400
+++ new/usr/src/cmd/cmd-inet/usr.lib/wanboot/p12split/p12split.c	2014-05-16 10:29:50.738809518 +0400
@@ -24,8 +24,6 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <stdio.h>
 #include <libintl.h>
 #include <locale.h>
@@ -262,7 +260,6 @@
 			int i;
 
 			for (i = 0; i < sk_X509_num(ta_in); i++) {
-				/* LINTED */
 				x = sk_X509_value(ta_in, i);
 				(void) printf(
 				    gettext("\nTrust Anchor cert %d:\n"), i);
@@ -287,7 +284,7 @@
 				}
 
 				(void) sunw_print_times(stdout, PRNT_BOTH,
-					NULL, x);
+				    NULL, x);
 			}
 		}
 	}
@@ -376,13 +373,11 @@
 		return;
 
 	for (i = 0; i < sk_X509_num(ta_in); ) {
-		/* LINTED */
 		curr = sk_X509_value(ta_in, i);
 		ret = time_check_print(curr);
 		if ((ret != CHK_TIME_OK && ret != CHK_TIME_IS_BEFORE) &&
 		    del_expired) {
 			(void) fprintf(stderr, gettext("  Removing cert\n"));
-			/* LINTED */
 			curr = sk_X509_delete(ta_in, i);
 			X509_free(curr);
 			continue;
@@ -586,14 +581,12 @@
 	 */
 	if (clist != NULL) {
 		if (cert != NULL && sk_X509_num(clist) == 1) {
-			/* LINTED */
 			(void) sk_X509_delete(clist, 0);
 		}
 		sk_X509_pop_free(clist, X509_free);
 	}
 	if (klist != NULL) {
 		if (pkey != NULL && sk_EVP_PKEY_num(klist) == 1) {
-			/* LINTED */
 			(void) sk_EVP_PKEY_delete(klist, 0);
 		}
 		sk_EVP_PKEY_pop_free(klist, sunw_evp_pkey_free);
--- old/usr/src/cmd/cmd-inet/usr.lib/wanboot/wanboot-cgi/Makefile	2014-05-16 10:29:50.980205303 +0400
+++ new/usr/src/cmd/cmd-inet/usr.lib/wanboot/wanboot-cgi/Makefile	2014-05-16 10:29:50.988335262 +0400
@@ -25,9 +25,12 @@
 include ../Makefile.com
 
 PROG =		wanboot-cgi
-LDLIBS +=	-lgen -lnsl -lwanbootutil -lnvpair -lwanboot -lcrypto
+LDLIBS +=	-lgen -lnsl -lwanbootutil -lnvpair -lwanboot
 CPPFLAGS +=	-I$(CMNCRYPTDIR)
 
+# libcrypto has no lint library, so we can only include this while building
+$(PROG) := LDLIBS += -lcrypto
+
 all:		$(PROG)
 
 install:	all $(ROOTCMD)
--- old/usr/src/cmd/cmd-inet/usr.lib/wanboot/wanboot-cgi/wanboot-cgi.c	2014-05-16 10:29:51.216182157 +0400
+++ new/usr/src/cmd/cmd-inet/usr.lib/wanboot/wanboot-cgi/wanboot-cgi.c	2014-05-16 10:29:51.224812172 +0400
@@ -877,7 +877,6 @@
 	 * Merge the two stacks of pkcs12 certs.
 	 */
 	for (i = 0; i < sk_X509_num(i_anchors); i++) {
-		/* LINTED */
 		x = sk_X509_delete(i_anchors, i);
 		(void) sk_X509_push(o_anchors, x);
 	}
@@ -1090,7 +1089,6 @@
 	p12 = NULL;
 
 	for (i = 0; i < sk_X509_num(certs); i++) {
-		/* LINTED */
 		x = sk_X509_value(certs, i);
 		if (!one_name(sunw_issuer_attrs(x, buf, sizeof (buf) - 1),
 		    nvl)) {
--- old/usr/src/cmd/ssh/libssh/Makefile.com	2014-05-16 10:29:51.501223187 +0400
+++ new/usr/src/cmd/ssh/libssh/Makefile.com	2014-05-16 10:29:51.509361792 +0400
@@ -94,7 +94,7 @@
 # Define LDLIBS conditionally for lintcheck, rather than in general, since
 # we're building an archive library which itself links to nothing, we just
 # want lint to know about these libraries.
-lintcheck  :=	LDLIBS += -lcrypto -lz -lsocket -lnsl -lc
+lintcheck  :=	LDLIBS += -lz -lsocket -lnsl -lc
 $(LINTLIB) :=	SRCS = $(SRCDIR)/$(LINTSRC)
 
 POFILE_DIR =	../..
--- old/usr/src/cmd/ssh/sftp-server/Makefile	2014-05-16 10:29:51.736932336 +0400
+++ new/usr/src/cmd/ssh/sftp-server/Makefile	2014-05-16 10:29:51.745775635 +0400
@@ -31,7 +31,10 @@
 include ../../Makefile.cmd
 include ../Makefile.ssh-common
 
-LDLIBS +=	$(SSH_COMMON_LDLIBS) -lsocket -lcrypto
+LDLIBS +=	$(SSH_COMMON_LDLIBS) -lsocket
+
+# libcrypto has no lint library, so we can only use it when building
+$(PROG) := 	LDLIBS += -lcrypto
 
 POFILE_DIR =	..
 
--- old/usr/src/cmd/ssh/sftp/Makefile	2014-05-16 10:29:51.971602250 +0400
+++ new/usr/src/cmd/ssh/sftp/Makefile	2014-05-16 10:29:51.979760885 +0400
@@ -35,7 +35,10 @@
 include ../../Makefile.cmd
 include ../Makefile.ssh-common
 
-LDLIBS +=	$(SSH_COMMON_LDLIBS) -lsocket -lcrypto -ltecla
+LDLIBS +=	$(SSH_COMMON_LDLIBS) -lsocket -ltecla
+
+# libcrypto has no lint library, so we can only use it when building
+$(PROG) := LDLIBS += -lcrypto
 
 POFILE_DIR =	..
 
--- old/usr/src/cmd/ssh/ssh-add/Makefile	2014-05-16 10:29:52.208751689 +0400
+++ new/usr/src/cmd/ssh/ssh-add/Makefile	2014-05-16 10:29:52.217239237 +0400
@@ -32,7 +32,10 @@
 include ../../Makefile.cmd
 include ../Makefile.ssh-common
 
-LDLIBS += $(SSH_COMMON_LDLIBS) -lsocket -lcrypto
+LDLIBS += $(SSH_COMMON_LDLIBS) -lsocket
+
+# libcrypto has no lint library, so we can only use it when building
+$(PROG) := LDLIBS += -lcrypto
 
 POFILE_DIR= ..
 
--- old/usr/src/cmd/ssh/ssh-agent/Makefile	2014-05-16 10:29:52.445697556 +0400
+++ new/usr/src/cmd/ssh/ssh-agent/Makefile	2014-05-16 10:29:52.454414072 +0400
@@ -32,7 +32,10 @@
 include ../../Makefile.cmd
 include ../Makefile.ssh-common
 
-LDLIBS += $(SSH_COMMON_LDLIBS) -lsocket -lcrypto
+LDLIBS += $(SSH_COMMON_LDLIBS) -lsocket
+
+# libcrypto has no lint library, so we can only use it when building
+$(PROG) := LDLIBS += -lcrypto
 
 POFILE_DIR= ..
 
--- old/usr/src/cmd/ssh/ssh-keygen/Makefile	2014-05-16 10:29:52.679512520 +0400
+++ new/usr/src/cmd/ssh/ssh-keygen/Makefile	2014-05-16 10:29:52.687500285 +0400
@@ -32,7 +32,10 @@
 include ../../Makefile.cmd
 include ../Makefile.ssh-common
 
-LDLIBS += $(SSH_COMMON_LDLIBS) -lcrypto -lsocket
+LDLIBS += $(SSH_COMMON_LDLIBS) -lsocket
+
+# libcrypto has no lint library, so we can only use it when building
+$(PROG) := LDLIBS += -lcrypto
 
 POFILE_DIR= ..
 
--- old/usr/src/cmd/ssh/ssh-keyscan/Makefile	2014-05-16 10:29:52.916455727 +0400
+++ new/usr/src/cmd/ssh/ssh-keyscan/Makefile	2014-05-16 10:29:52.925053233 +0400
@@ -32,7 +32,10 @@
 include ../../Makefile.cmd
 include ../Makefile.ssh-common
 
-LDLIBS += $(SSH_COMMON_LDLIBS) -lsocket -lnsl -lz -lcrypto
+LDLIBS += $(SSH_COMMON_LDLIBS) -lsocket -lnsl -lz
+
+# libcrypto has no lint library, so we can only use it when building
+$(PROG) := LDLIBS += -lcrypto
 
 POFILE_DIR= ..
 
--- old/usr/src/cmd/ssh/ssh-keysign/Makefile	2014-05-16 10:29:53.151260816 +0400
+++ new/usr/src/cmd/ssh/ssh-keysign/Makefile	2014-05-16 10:29:53.159328210 +0400
@@ -36,7 +36,10 @@
 
 FILEMODE= 04555
 
-LDLIBS += $(SSH_COMMON_LDLIBS) -lsocket -lnsl -lz -lcrypto
+LDLIBS += $(SSH_COMMON_LDLIBS) -lsocket -lnsl -lz
+
+# libcrypto has no lint library, so we can only use it when building
+$(PROG) := LDLIBS += -lcrypto
 
 POFILE_DIR= ..
 
--- old/usr/src/cmd/ssh/ssh/Makefile	2014-05-16 10:29:53.388879243 +0400
+++ new/usr/src/cmd/ssh/ssh/Makefile	2014-05-16 10:29:53.397205338 +0400
@@ -40,9 +40,11 @@
 LDLIBS += $(SSH_COMMON_LDLIBS) -lsocket \
 	-lnsl \
 	-lz \
-	-lcrypto \
 	-lgss
 
+# libcrypto has no lint library, so we can only use it when building
+$(PROG) := LDLIBS += -lcrypto
+
 POFILE_DIR= ..
 
 .KEEP_STATE:
--- old/usr/src/cmd/ssh/sshd/Makefile	2014-05-16 10:29:53.622798734 +0400
+++ new/usr/src/cmd/ssh/sshd/Makefile	2014-05-16 10:29:53.631140326 +0400
@@ -75,12 +75,14 @@
 	-lpam \
 	-lbsm \
 	-lwrap \
-	-lcrypto \
 	-lgss \
 	-lcontract
 MAPFILES = $(MAPFILE.INT) $(MAPFILE.NGB)
 LDFLAGS += $(MAPFILES:%=-M%)
 
+# libcrypto has no lint library, so we can only use it when building
+$(PROG) := LDLIBS += -lcrypto
+
 POFILE_DIR= ..
 
 .KEEP_STATE:
--- old/usr/src/common/net/wanboot/boot_http.c	2014-05-16 10:29:53.867181104 +0400
+++ new/usr/src/common/net/wanboot/boot_http.c	2014-05-16 10:29:53.875484616 +0400
@@ -2254,7 +2254,6 @@
 		return;
 
 	for (i = 0; i < sk_SSL_CIPHER_num(sk); i++) {
-		/* LINTED */
 		c = sk_SSL_CIPHER_value(sk, i);
 		libbootlog(BOOTLOG_VERBOSE, "%08lx %s", c->id, c->name);
 	}
--- old/usr/src/lib/libkmf/plugins/kmf_openssl/Makefile.com	2014-05-16 10:29:54.180172246 +0400
+++ new/usr/src/lib/libkmf/plugins/kmf_openssl/Makefile.com	2014-05-16 10:29:54.188688763 +0400
@@ -40,8 +40,8 @@
 OPENSSLLIBS=	$(BERLIB) -lcrypto -lcryptoutil -lc
 OPENSSLLIBS64=	$(BERLIB64) -lcrypto -lcryptoutil -lc
 
-LINTSSLLIBS	= $(BERLIB) -lcrypto -lcryptoutil -lc
-LINTSSLLIBS64	= $(BERLIB64) -lcrypto -lcryptoutil -lc
+LINTSSLLIBS	= $(BERLIB) -lcryptoutil -lc
+LINTSSLLIBS64	= $(BERLIB64) -lcryptoutil -lc
 
 SRCDIR=		../common
 INCDIR=		../../include
--- old/usr/src/lib/libkmf/plugins/kmf_openssl/common/openssl_spi.c	2014-05-16 10:29:54.419952340 +0400
+++ new/usr/src/lib/libkmf/plugins/kmf_openssl/common/openssl_spi.c	2014-05-16 10:29:54.428828424 +0400
@@ -2033,7 +2033,7 @@
 #if OPENSSL_VERSION_NUMBER < 0x10000000L
 	STACK *emlst = NULL;
 #else
-        STACK_OF(OPENSSL_STRING) *emlst = NULL;
+	STACK_OF(OPENSSL_STRING) *emlst = NULL;
 #endif
 	X509_EXTENSION *ex;
 	X509_CINF *ci;
@@ -2153,7 +2153,7 @@
 #else
 		for (j = 0; j < sk_OPENSSL_STRING_num(emlst); j++)
 			(void) BIO_printf(mem, "%s\n",
-                            sk_OPENSSL_STRING_value(emlst, j));
+			    sk_OPENSSL_STRING_value(emlst, j));
 #endif
 
 		len = BIO_gets(mem, resultStr, KMF_CERT_PRINTABLE_LEN);
@@ -2499,7 +2499,6 @@
 	keyhash = id->value.byKey->data;
 	/* Calculate hash of each key and compare */
 	for (i = 0; i < sk_X509_num(certs); i++) {
-		/* LINTED E_BAD_PTR_CAST_ALIGN */
 		X509 *x = sk_X509_value(certs, i);
 		/* Use pubkey_digest to get the key ID value */
 		(void) X509_pubkey_digest(x, EVP_sha1(), tmphash, NULL);
@@ -3639,7 +3638,6 @@
 	}
 
 	for (i = 0; i < sk_X509_INFO_num(x509_info_stack); i++) {
-		/* LINTED E_BAD_PTR_CAST_ALIGN */
 		cert_infos[ncerts] = sk_X509_INFO_value(x509_info_stack, i);
 		ncerts++;
 	}
@@ -3721,7 +3719,6 @@
 err:
 	/* Cleanup the stack of X509 info records */
 	for (i = 0; i < sk_X509_INFO_num(x509_info_stack); i++) {
-		/* LINTED E_BAD_PTR_CAST_ALIGN */
 		info = (X509_INFO *)sk_X509_INFO_value(x509_info_stack, i);
 		X509_INFO_free(info);
 	}
@@ -3742,7 +3739,6 @@
 	int i;
 
 	for (i = 0; i < sk_PKCS12_SAFEBAG_num(bags); i++) {
-		/* LINTED E_BAD_PTR_CAST_ALIGN */
 		PKCS12_SAFEBAG *bag = sk_PKCS12_SAFEBAG_value(bags, i);
 		ret = openssl_parse_bag(bag, pin, (pin ? strlen(pin) : 0),
 		    keys, certs);
@@ -3773,12 +3769,10 @@
 		X509_ATTRIBUTE *a;
 		for (i = 0;
 		    i < sk_X509_ATTRIBUTE_num(pkey->attributes); i++) {
-			/* LINTED E_BAD_PTR_CASE_ALIGN */
 			a = sk_X509_ATTRIBUTE_value(pkey->attributes, i);
 			if (OBJ_obj2nid(a->object) == nid) {
 				X509_ATTRIBUTE_free(a);
-				/* LINTED E_BAD_PTR_CAST_ALIGN */
-				sk_X509_ATTRIBUTE_set(pkey->attributes,
+				(void) sk_X509_ATTRIBUTE_set(pkey->attributes,
 				    i, attr);
 				return (KMF_OK);
 			}
@@ -3955,7 +3949,6 @@
 
 	for (i = 0; ret == KMF_OK && i < sk_PKCS7_num(asafes); i++) {
 		bags = NULL;
-		/* LINTED E_BAD_PTR_CAST_ALIGN */
 		p7 = sk_PKCS7_value(asafes, i);
 		bagnid = OBJ_obj2nid(p7->type);
 
@@ -4233,7 +4226,6 @@
 		return (NULL);
 
 	for (i = 0; i < sk_X509_ATTRIBUTE_num(attrs); i++) {
-		/* LINTED E_BAD_PTR_CAST_ALIGN */
 		a = sk_X509_ATTRIBUTE_value(attrs, i);
 		if (OBJ_obj2nid(a->object) == nid)
 			return (a);
@@ -4274,7 +4266,6 @@
 		ASN1_TYPE *ty = NULL;
 		int numattr = sk_ASN1_TYPE_num(attr->value.set);
 		if (attr->single == 0 && numattr > 0) {
-			/* LINTED E_BAD_PTR_CAST_ALIGN */
 			ty = sk_ASN1_TYPE_value(attr->value.set, 0);
 		}
 		if (ty != NULL) {
@@ -4298,7 +4289,6 @@
 		ASN1_TYPE *ty = NULL;
 		int numattr = sk_ASN1_TYPE_num(attr->value.set);
 		if (attr->single == 0 && numattr > 0) {
-			/* LINTED E_BAD_PTR_CAST_ALIGN */
 			ty = sk_ASN1_TYPE_value(attr->value.set, 0);
 		}
 		key->id.Data = (uchar_t *)malloc(
@@ -4329,7 +4319,6 @@
 	int i;
 
 	for (i = 0; sslkeys != NULL && i < sk_EVP_PKEY_num(sslkeys); i++) {
-		/* LINTED E_BAD_PTR_CAST_ALIGN */
 		EVP_PKEY *pkey = sk_EVP_PKEY_value(sslkeys, i);
 		rv = convertToRawKey(pkey, &key);
 		if (rv == KMF_OK)
@@ -4341,7 +4330,6 @@
 
 	/* Now add the certificate to the certlist */
 	for (i = 0; sslcert != NULL && i < sk_X509_num(sslcert); i++) {
-		/* LINTED E_BAD_PTR_CAST_ALIGN */
 		X509 *cert = sk_X509_value(sslcert, i);
 		rv = add_cert_to_list(kmfh, cert, certlist, ncerts);
 		if (rv != KMF_OK)
@@ -4357,7 +4345,6 @@
 		 * Lint is complaining about the embedded casting, and
 		 * to fix it, you need to fix openssl header files.
 		 */
-		/* LINTED E_BAD_PTR_CAST_ALIGN */
 		c = sk_X509_value(sslcacerts, i);
 
 		/* Now add the ca cert to the certlist */
@@ -5424,7 +5411,6 @@
 	}
 
 	for (i = 0; i < sk_X509_REVOKED_num(revoke_stack); i++) {
-		/* LINTED E_BAD_PTR_CAST_ALIGN */
 		revoke = sk_X509_REVOKED_value(revoke_stack, i);
 		if (ASN1_INTEGER_cmp(xcert->cert_info->serialNumber,
 		    revoke->serialNumber) == 0) {
--- old/usr/src/lib/libpkg/Makefile.com	2014-05-16 10:29:54.825714462 +0400
+++ new/usr/src/lib/libpkg/Makefile.com	2014-05-16 10:29:54.834869281 +0400
@@ -64,7 +64,11 @@
 LIBS = $(DYNLIB) $(LINTLIB)
 
 
-LDLIBS +=	-lc -lssl -lwanboot -lcrypto -lscf -ladm
+LDLIBS +=	-lc -lwanboot -lscf -ladm
+
+# libcrypto and libssl have no lint library, and so can only be used when
+# building
+$(DYNLIB) := LDLIBS += -lcrypto -lssl
 
 CFLAGS +=	$(CCVERBOSE)
 CERRWARN +=	-_gcc=-Wno-unused-label
--- old/usr/src/lib/libpkg/common/security.c	2014-05-16 10:29:55.060759020 +0400
+++ new/usr/src/lib/libpkg/common/security.c	2014-05-16 10:29:55.068736583 +0400
@@ -110,7 +110,6 @@
 
 	/* add all ca certs into the store */
 	for (i = 0; i < sk_X509_num(cas); i++) {
-		/* LINTED pointer cast may result in improper alignment */
 		ca_cert = sk_X509_value(cas, i);
 		if (X509_STORE_add_cert(ca_store, ca_cert) == 0) {
 			pkgerr_add(err, PKGERR_NOMEM, gettext(ERR_MEM));
@@ -174,8 +173,7 @@
 	    NID_commonName, sname,
 	    ATTR_MAX) <= 0) {
 		(void) strncpy(sname,
-		    X509_NAME_oneline(xname,
-			NULL, 0), ATTR_MAX);
+		    X509_NAME_oneline(xname, NULL, 0), ATTR_MAX);
 		sname[ATTR_MAX - 1] = '\0';
 	}
 	return (sname);
@@ -205,8 +203,7 @@
 	    NID_commonName, sname,
 	    ATTR_MAX) <= 0) {
 		(void) strncpy(sname,
-		    X509_NAME_oneline(xname,
-			NULL, 0), ATTR_MAX);
+		    X509_NAME_oneline(xname, NULL, 0), ATTR_MAX);
 		sname[ATTR_MAX - 1] = '\0';
 	}
 	return (sname);
--- old/usr/src/lib/libwanboot/Makefile.com	2014-05-16 10:29:55.300479468 +0400
+++ new/usr/src/lib/libwanboot/Makefile.com	2014-05-16 10:29:55.308596288 +0400
@@ -60,7 +60,12 @@
 
 LIBS +=		$(LINTLIB)
 LDLIBS +=	-lnvpair -lresolv -lnsl -lsocket -ldevinfo -ldhcputil \
-		-linetutil -lc -lcrypto -lssl
+		-linetutil -lc
+
+# libcrypto and libssl have no lint library, so we can only use it when
+# building
+$(DYNLIB) := LDLIBS += -lcrypto -lssl
+
 CPPFLAGS =	-I$(SRC)/common/net/wanboot/crypt $(CPPFLAGS.master)
 CERRWARN +=	-_gcc=-Wno-switch
 CERRWARN +=	-_gcc=-Wno-parentheses
--- old/usr/src/lib/pkcs11/pkcs11_tpm/Makefile.com	2014-05-16 10:29:55.533911336 +0400
+++ new/usr/src/lib/pkcs11/pkcs11_tpm/Makefile.com	2014-05-16 10:29:55.541723693 +0400
@@ -73,7 +73,12 @@
 TSSLIB64=-L$(TSPILIBDIR)/$(MACH64)
 TSSINC=-I$(TSPIINCDIR)
 
-LDLIBS += $(TSSLIB) -L$(ADJUNCT_PROTO)/lib -lc -luuid -lmd -ltspi -lcrypto
+LDLIBS += $(TSSLIB) -L$(ADJUNCT_PROTO)/lib -lc -luuid -lmd -ltspi
+
+# libcrypto has no lint library, so we can only use it when
+# building
+$(LIBS) := LDLIBS += -lcrypto
+
 CPPFLAGS += -xCC -D_POSIX_PTHREAD_SEMANTICS $(TSSINC)
 CPPFLAGS64 += $(CPPFLAGS)
 C99MODE=        $(C99_ENABLE)
